local AceAddon = AceLibrary("AceAddon-2.0")
local Tablet = AceLibrary("Tablet-2.0")
local Tooltip = AceLibrary("Gratuity-2.0")

local L = AceLibrary("AceLocale-2.2"):new("Cartographer_Vendors")
L:RegisterTranslations("enUS", function() return {
	["Filter"] = true,
	["Filter out vendors"] = true,
	
    ["Vendors"] = true,
    ["Module description"] = "Vendor Mapnotes for Cartographer",
  
	["Select all"] = true,
	["Select none"] = true,

    ["Icon alpha"] = true,
	["Alpha transparency of the icon"] = true,
	["Icon size"] = true,
	["Size of the icons on the map"] = true,    
    ["Show minimap icons"] = true,
    ["Show vendor icons on the minimap"] = true,
    ["Show minimap tracking icons"] = true,
    ["Show vendor tracking icons on the minimap"] = true,
    
    ["Import"] = true,
    ["Import vendors"] = true,
    ["Rebuild"] = true,
    ["Rebuild vendors"] = true,

    -- Filters
    ["Vendor"] = true,
    ["Armorer"] = true,
    ["Merchants"] = true,
    ["Food and Drink"] = true,
    ["Armor"] = true,
    ["Weapons"] = true,
    ["Goods"] = true,
    ["Miscellaneous"] = true,
    ["Trainers"] = true,
 
    -- Vendor types
    ["Darkmoon Faire Drink Vendor"] = true,
    ["Leather & Mail Armor Merchant"] = true,
    ["Defilers Supply Officer"] = true,
    ["Two-Handed Weapons Merchant"] = true,
    ["Quartermaster"] = true,
    ["Tradesman"] = true,
    ["Sword and Dagger Merchant"] = true,
    ["Wands Merchant"] = true,
    ["Cloth and Leather Merchant"] = true,
    ["Thrown Weapons Merchant"] = true,
    ["War Harness Vendor"] = true,
    ["Tools & Supplies"] = true,
    ["Guns Merchant"] = true,
    ["Thrallmar Quartermaster"] = true,
    ["Chef"] = true,
    ["Bow Merchant"] = true,
    ["Superior Macecrafter"] = true,
    ["Prairie Dog Vendor"] = true,
    ["Bowyer"] = true,
    ["Bread Merchant"] = true,
    ["Mail & Plate Merchant"] = true,
    ["Trade Supplies"] = true,
    ["Wand Vendor"] = true,
    ["Enchanting Supplies"] = true,
    ["Robe Merchant"] = true,
    ["Fish Merchant & Supplies"] = true,
    ["Weapon Crafter"] = true,
    ["Fungus Vendor"] = true,
    ["Weapon Merchant"] = true,
    ["Tailoring Supplier"] = true,
    ["Reagent Supplies"] = true,
    ["Cockroach Vendor"] = true,
    ["Alchemy & Herbalism Supplies"] = true,
    ["Trade Goods"] = true,
    ["Wand Merchant"] = true,
    ["Stormpike Supply Officer"] = true,
    ["Undead Horse Merchant"] = true,
    ["Armor Merchant"] = true,
    ["Armorsmith"] = true,
    ["Mushroom Merchant"] = true,
    ["Jewelcrafting Supplier"] = true,
    ["Poison Supplies"] = true,
    ["Armor & Shield Merchant"] = true,
    ["Armorsmith & Blacksmithing Supplies"] = true,
    ["Weapons Merchant"] = true,
    ["Horde Cloth Quartermaster"] = true,
    ["Consortium Quartermaster"] = true,
    ["Cloth Armor Merchant"] = true,
    ["Reagent Supplier"] = true,
    ["Staff Vendor"] = true,
    ["War Harness Maker"] = true,
    ["Alliance Cloth Quartermaster"] = true,
    ["Weaponsmith"] = true,
    ["General Supplies"] = true,
    ["Exotic Reagent Merchant"] = true,
    ["Jewelcrafting Supplies Vendor"] = true,
    ["Cooking Supplies"] = true,
    ["Superior Tradesman"] = true,
    ["Mining Supplier"] = true,
    ["Kurenai Quartermaster"] = true,
    ["Mag'har Quartermaster"] = true,
    ["Herbalism Supplier"] = true,
    ["Mining Supplies"] = true,
    ["Mechanostrider Merchant"] = true,
    ["Blade Vendor"] = true,
    ["Fisherman Supplies"] = true,
    ["Staves Merchant"] = true,
    ["Bread Vendor"] = true,
    ["Traveling Merchant"] = true,
    ["Shield Crafter"] = true,
    ["Fruit Vendor"] = true,
    ["Alpha Gem Vendor"] = true,
    ["Two Handed Weapon Merchant"] = true,
    ["Food Vendor"] = true,
    ["Weapons and Armor Merchant"] = true,
    ["Gunsmith"] = true,
    ["Dagger Vendor"] = true,
    ["Pie Vendor"] = true,
    ["Bait and Tackle Supplier"] = true,
    ["Food & Drink Vendor"] = true,
    ["Scryers: Quartermaster"] = true,
    ["Leather Armor Merchant"] = true,
    ["Silverwing Supply Officer"] = true,
    ["Mace & Staff Merchant"] = true,
    ["Engineering and Mining Supplies"] = true,
    ["Arena Vendor"] = true,
    ["Robe Vendor"] = true,
    ["Frostwolf Supply Officer"] = true,
    ["Fireworks Vendor"] = true,
    ["Fireworks Merchant"] = true,
    ["Bow & Gun Merchant"] = true,
    ["General Goods"] = true,
    ["Alchemy Supplies"] = true,
    ["Enchanting Supplier"] = true,
    ["Speciality Tailoring Supplies"] = true,
    ["Reagent Merchant"] = true,
    ["Food and Drink"] = true,
    ["General Trade Goods Vendor"] = true,
    ["Wine Vendor"] = true,
    ["Sword Vendor"] = true,
    ["Speciality Dress Maker"] = true,
    ["Gun Merchant"] = true,
    ["General Trade Supplier"] = true,
    ["Mining and Smithing Supplies"] = true,
    ["Light Armor Merchant"] = true,
    ["Fish Merchant"] = true,
    ["Mail Armor Merchant"] = true,
    ["Honor Hold Quartermaster"] = true,
    ["Guild Tabard Vendor"] = true,
    ["Tailoring Supplies"] = true,
    ["Macecrafter"] = true,
    ["Leather Armor & Leatherworking Supplies"] = true,
    ["Warsong Supply Officer"] = true,
    ["Herbalism & Alchemy Supplies"] = true,
    ["Ammunition Vendor"] = true,
    ["Leatherworking Supplier"] = true,
    ["Bag Vendor"] = true,
    ["Ice Cream Vendor"] = true,
    ["Cheese Vendor"] = true,
    ["Fish Vendor"] = true,
    ["Venture Co. Merchant"] = true,
    ["Engineering Supplies"] = true,
    ["Trade Goods Supplier"] = true,
    ["Supplies"] = true,
    ["Free Wheeling Merchant"] = true,
    ["League of Arathor Supply Officer"] = true,
    ["Engineering & General Goods Supplier"] = true,
    ["Accessories Quartermaster"] = true,
    ["Light Armor & Weapons Merchant"] = true,
    ["Meat Vendor"] = true,
    ["Gem Vendor"] = true,
    ["Weapon Vendor"] = true,
    ["Reagents Vendor"] = true,
    ["Cenarion Expedition Quartermaster"] = true,
    ["Poison Supplier"] = true,
    ["Armor Crafter"] = true,
    ["General Goods Merchant"] = true,
    ["Blunt Weapon Merchant"] = true,
    ["Cooking Trainer and Supplies"] = true,
    ["Arcane Trinkets Vendor"] = true,
    ["General & Trade Supplies"] = true,
    ["Heavy Armor Merchant"] = true,
    ["Fishing Supplier"] = true,
    ["Sporeggar Quartermaster"] = true,
    ["Merchant"] = true,
    ["Bow & Arrow Merchant"] = true,
    ["Axe Merchant"] = true,
    ["Cloth & Leather Armor Merchant"] = true,
    ["Staff Merchant"] = true,
    ["Specialty Tailoring Supplies"] = true,
    ["Special Weapon Crafter"] = true,
    ["Pirate Supplies"] = true,
    ["Trade Supplier"] = true,
    ["Darkmoon Faire Food Vendor"] = true,
    ["Tabard Vendor"] = true,
    ["Healing & Sustenance"] = true,
    ["Shield Merchant"] = true,
    ["Blacksmithing Trainer and Supplies"] = true,
    ["Cloth & Leather Merchant"] = true,
    ["Arcane Goods Vendor"] = true,
    ["Bag Merchant"] = true,
    ["Leatherworking Supplies"] = true,
    ["Superior Armor Crafter"] = true,
    ["Butcher"] = true,
    ["Trade Goods Supplies"] = true,
    ["Trade Goods Vendor"] = true,
    ["Scrolls & Potions"] = true,
    ["Food & Drink Merchant"] = true,
    ["Leatherworking & Tailoring Supplies"] = true,
    ["General Goods Vendor"] = true,
    ["Cooking Supplier"] = true,
    ["Rations"] = true,
    ["Beverage Merchant"] = true,
    ["Reagent Vendor"] = true,
    ["Engineering Supplier"] = true,
    ["Fishing Trainer & Supplies"] = true,
    ["Blacksmithing Supplies"] = true,
    ["Innkeeper"] = true,
    ["Blacksmithing Supplier"] = true,
    ["Keepers of Time Quartermaster"] = true,
    ["Staff & Mace Merchant"] = true,
    ["Fishing Supplies"] = true,
    ["Poison Vendor"] = true,
    ["Specialist Tailoring Supplies"] = true,
    ["Drink Vendor"] = true,
    ["Mace & Staves Vendor"] = true,
    ["Mushroom Vendor"] = true,
    ["Guns and Ammo Merchant"] = true,
    ["Blade Merchant"] = true,
    ["General Trade Goods Merchant"] = true,
    ["Wine & Spirits Merchant"] = true,    
    
} end)

L:RegisterTranslations("koKR", function() return {
	["Filter"] = "필터",
	["Filter out vendors"] = "상인 아웃 필터",

    ["Vendors"] = "상인",
    ["Module description"] = "맵노트에 상인을 표시합니다.",
	
	["Select all"] = "모두 선택",
	["Select none"] = "선택 없음",

	["Icon alpha"] = "아이콘 투명도",
	["Alpha transparency of the icon"] = "아이콘의 투명도를 조절합니다.",
	["Icon size"] = "아이콘 크기",
	["Size of the icons on the map"] = "아이콘의 크기를 조절합니다.",
    ["Show minimap icons"] = "미니맵 아이콘 보기",
    ["Show vendor icons on the minimap"] = "미니맵에 상인 아이콘을 표시합니다.",
    
    ["Import"] = "입력",
    ["Import vendors"] = "상인 정보를 입력합니다.",
    ["Rebuild"] = true,
    ["Rebuild vendors"] = true,
    
    ["Vendor"] = "상인",
    ["Armorer"] = "방어구 상인",
} end)

L:RegisterTranslations("deDE", function() return {
	["Filter"] = "Filter",
	["Filter out vendors"] = "H\195\164ndler filtern",
	
    ["Vendors"] = "H\195\164ndler",
    ["Module description"] = "H\195\164ndler-Kartennotizen f\195\88r Cartographer",
  
	["Select all"] = "Alles ausw\195\164hlen",
	["Select none"] = "Nichts ausw\195\164hlen",

    ["Icon alpha"] = "Transparenz",
    ["Alpha transparency of the icon"] = "Transparenz der Symbole",
    ["Icon size"] = "Symbolgr\195\182\195\159e",
    ["Size of the icons on the map"] = "Gr\195\182\195\159e des Symbols auf der Karte",
    ["Show minimap icons"] = true,
    ["Show vendor icons on the minimap"] = true,
    ["Show minimap tracking icons"] = true,
    ["Show vendor tracking icons on the minimap"] = true,
    
    ["Import"] = true,
    ["Import vendors"] = true,
    ["Rebuild"] = true,
    ["Rebuild vendors"] = true,
    
    ["Vendor"] = "H\195\164ndler",
} end)

L:RegisterTranslations("zhTW", function() return {
	["Filter"] = "篩檢",
	["Filter out vendors"] = "篩檢商人",
	
    ["Vendors"] = "商人",
    ["Module description"] = "Cartographer 商人地圖註記",

    ["Select all"] = "全部選擇",
    ["Select none"] = "全部取消",
    
    ["Icon alpha"] = true,
	["Alpha transparency of the icon"] = true,
	["Icon size"] = true,
	["Size of the icons on the map"] = true,    
    ["Show minimap icons"] = true,
    ["Show vendor icons on the minimap"] = true,
    ["Show minimap tracking icons"] = true,
    ["Show vendor tracking icons on the minimap"] = true,
    
    ["Import"] = true,
    ["Import vendors"] = true,
    ["Rebuild"] = true,
    ["Rebuild vendors"] = true,    

    ["Vendor"] = "商人",
} end)

L:RegisterTranslations("esES", function() return {
	["Filter"] = "Filtrar",
	["Filter out vendors"] = "Filtra vendedores",
	
    ["Vendors"] = "Vendedores",
    ["Module description"] = "Notas de mapa de vendedores para Cartographer",

    ["Select all"] = "Seleccionar todo",
    ["Select none"] = "No seleccionar nada",

    ["Icon alpha"] = "Transparencia de icono",
    ["Alpha transparency of the icon"] = "Transparencia del icono",
    ["Icon size"] = "Tama\195\177o del icono",
    ["Size of the icons on the map"] = "Tama\195\177o de los iconos en el mapa",
    ["Show minimap icons"] = "Mostrar iconos en minimapa",
    ["Show vendor icons on the minimap"] = "Muestra los iconos de vendedores en el minimapa",
    ["Show minimap tracking icons"] = true,
    ["Show vendor tracking icons on the minimap"] = true,
    
    ["Import"] = true,
    ["Import vendors"] = true,
    ["Rebuild"] = true,
    ["Rebuild vendors"] = true,    
    
    ["Vendor"] = "Vendedor",
} end)

Cartographer_Vendors = Cartographer:NewModule("Vendors", "AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0")
Cartographer_Vendors:RegisterDB("Cartographer_VendorsDB")

Cartographer_Vendors.filters = {
    ["Trainers"] = L["Trainers"],
    ["Food and Drink"] = L["Food and Drink"],
    ["Goods"] = L["Goods"],
    ["Armor"] = L["Armor"],
    ["Weapons"] = L["Weapons"],
    ["Merchants"] = L["Merchants"],
    ["Miscellaneous"] = L["Miscellaneous"],
}

Cartographer_Vendors.lookups = {
    ["filters"] = {
        ["Darkmoon Faire Drink Vendor"] = "Merchants",
        ["Leather & Mail Armor Merchant"] = "Merchants",
        ["Blade Merchant"] = "Merchants",
        ["Two-Handed Weapons Merchant"] = "Merchants",
        ["Quartermaster"] = "Miscellaneous",
        ["Tradesman"] = "Miscellaneous",
        ["Sword and Dagger Merchant"] = "Merchants",
        ["Wands Merchant"] = "Merchants",
        ["Cloth and Leather Merchant"] = "Merchants",
        ["Thrown Weapons Merchant"] = "Merchants",
        ["War Harness Vendor"] = "Merchants",
        ["Tools & Supplies"] = "Merchants",
        ["Guns Merchant"] = "Merchants",
        ["Thrallmar Quartermaster"] = "Miscellaneous",
        ["Chef"] = "Food and Drink",
        ["Bow Merchant"] = "Merchants",
        ["Superior Macecrafter"] = "Weapons",
        ["Prairie Dog Vendor"] = "Merchants",
        ["Bowyer"] = "Weapons",
        ["Bread Merchant"] = "Merchants",
        ["Mail & Plate Merchant"] = "Merchants",
        ["Trade Supplies"] = "Merchants",
        ["Wand Vendor"] = "Merchants",
        ["Enchanting Supplies"] = "Merchants",
        ["Robe Merchant"] = "Merchants",
        ["Fish Merchant & Supplies"] = "Merchants",
        ["Weapon Crafter"] = "Weapons",
        ["Blacksmithing Trainer and Supplies"] = "Merchants",
        ["Weapon Merchant"] = "Merchants",
        ["Reagent Vendor"] = "Merchants",
        ["Reagent Supplies"] = "Merchants",
        ["Cockroach Vendor"] = "Merchants",
        ["Alchemy & Herbalism Supplies"] = "Merchants",
        ["Trade Goods"] = "Goods",
        ["Wand Merchant"] = "Merchants",
        ["Stormpike Supply Officer"] = "Merchants",
        ["Undead Horse Merchant"] = "Merchants",
        ["Armor Merchant"] = "Merchants",
        ["Armorsmith"] = "Armor",
        ["Mushroom Merchant"] = "Merchants",
        ["Jewelcrafting Supplier"] = "Merchants",
        ["Poison Supplies"] = "Merchants",
        ["Armor & Shield Merchant"] = "Merchants",
        ["Armorsmith & Blacksmithing Supplies"] = "Merchants",
        ["Weapons Merchant"] = "Merchants",
        ["Horde Cloth Quartermaster"] = "Miscellaneous",
        ["Consortium Quartermaster"] = "Miscellaneous",
        ["Cloth Armor Merchant"] = "Merchants",
        ["Reagent Supplier"] = "Merchants",
        ["Staff Vendor"] = "Merchants",
        ["War Harness Maker"] = "Miscellaneous",
        ["Alliance Cloth Quartermaster"] = "Miscellaneous",
        ["Weaponsmith"] = "Weapons",
        ["General Supplies"] = "Merchants",
        ["Exotic Reagent Merchant"] = "Merchants",
        ["Jewelcrafting Supplies Vendor"] = "Merchants",
        ["Cooking Supplies"] = "Merchants",
        ["Superior Tradesman"] = "Miscellaneous",
        ["Mining Supplier"] = "Merchants",
        ["Herbalism Supplier"] = "Merchants",
        ["Mining Supplies"] = "Merchants",
        ["Blade Vendor"] = "Merchants",
        ["Staves Merchant"] = "Merchants",
        ["Bread Vendor"] = "Merchants",
        ["Kurenai Quartermaster"] = "Miscellaneous",
        ["Shield Crafter"] = "Miscellaneous",
        ["Fruit Vendor"] = "Merchants",
        ["Mag'har Quartermaster"] = "Miscellaneous",
        ["Two Handed Weapon Merchant"] = "Merchants",
        ["Mechanostrider Merchant"] = "Merchants",
        ["Weapons and Armor Merchant"] = "Merchants",
        ["Gunsmith"] = "Weapons",
        ["Dagger Vendor"] = "Merchants",
        ["Fisherman Supplies"] = "Merchants",
        ["Fish Merchant"] = "Merchants",
        ["Food & Drink Vendor"] = "Merchants",
        ["General Goods"] = "Goods",
        ["Food Vendor"] = "Merchants",
        ["Bait and Tackle Supplier"] = "Merchants",
        ["Mace & Staff Merchant"] = "Merchants",
        ["Engineering & General Goods Supplier"] = "Merchants",
        ["Mushroom Vendor"] = "Merchants",
        ["Robe Vendor"] = "Merchants",
        ["Silverwing Supply Officer"] = "Merchants",
        ["Fireworks Vendor"] = "Merchants",
        ["Fireworks Merchant"] = "Merchants",
        ["Poison Supplier"] = "Merchants",
        ["Engineering and Mining Supplies"] = "Merchants",
        ["Alchemy Supplies"] = "Merchants",
        ["Enchanting Supplier"] = "Merchants",
        ["Arena Vendor"] = "Merchants",
        ["Frostwolf Supply Officer"] = "Merchants",
        ["Bow & Gun Merchant"] = "Merchants",
        ["General Trade Goods Vendor"] = "Merchants",
        ["Beverage Merchant"] = "Merchants",
        ["Bag Merchant"] = "Merchants",
        ["Speciality Dress Maker"] = "Miscellaneous",
        ["Gun Merchant"] = "Merchants",
        ["General Trade Supplier"] = "Merchants",
        ["Mining and Smithing Supplies"] = "Merchants",
        ["Light Armor Merchant"] = "Merchants",
        ["Merchant"] = "Merchants",
        ["Shield Merchant"] = "Merchants",
        ["Honor Hold Quartermaster"] = "Miscellaneous",
        ["Wine Vendor"] = "Merchants",
        ["Tailoring Supplies"] = "Merchants",
        ["Sword Vendor"] = "Merchants",
        ["Scryers: Quartermaster"] = "Miscellaneous",
        ["Warsong Supply Officer"] = "Merchants",
        ["Reagent Merchant"] = "Merchants",
        ["Macecrafter"] = "Weapons",
        ["Leatherworking Supplier"] = "Merchants",
        ["Leather Armor & Leatherworking Supplies"] = "Merchants",
        ["Herbalism & Alchemy Supplies"] = "Merchants",
        ["Cheese Vendor"] = "Merchants",
        ["Ammunition Vendor"] = "Merchants",
        ["Trade Supplier"] = "Merchants",
        ["Engineering Supplies"] = "Merchants",
        ["Ice Cream Vendor"] = "Merchants",
        ["Darkmoon Faire Food Vendor"] = "Merchants",
        ["Venture Co. Merchant"] = "Merchants",
        ["League of Arathor Supply Officer"] = "Merchants",
        ["Trade Goods Supplier"] = "Merchants",
        ["Accessories Quartermaster"] = "Miscellaneous",
        ["Light Armor & Weapons Merchant"] = "Merchants",
        ["Meat Vendor"] = "Merchants",
        ["Gem Vendor"] = "Merchants",
        ["Free Wheeling Merchant"] = "Merchants",
        ["Poison Vendor"] = "Merchants",
        ["Cenarion Expedition Quartermaster"] = "Miscellaneous",
        ["Weapon Vendor"] = "Merchants",
        ["Armor Crafter"] = "Armor",
        ["General Goods Merchant"] = "Merchants",
        ["Fishing Supplies"] = "Merchants",
        ["Reagents Vendor"] = "Merchants",
        ["Arcane Trinkets Vendor"] = "Merchants",
        ["General & Trade Supplies"] = "Merchants",
        ["Heavy Armor Merchant"] = "Merchants",
        ["Fishing Supplier"] = "Merchants",
        ["Cooking Trainer and Supplies"] = "Merchants",
        ["Alpha Gem Vendor"] = "Merchants",
        ["Bow & Arrow Merchant"] = "Merchants",
        ["Blunt Weapon Merchant"] = "Merchants",
        ["Cloth & Leather Armor Merchant"] = "Merchants",
        ["Staff Merchant"] = "Merchants",
        ["Specialty Tailoring Supplies"] = "Merchants",
        ["Sporeggar Quartermaster"] = "Miscellaneous",
        ["Pirate Supplies"] = "Merchants",
        ["Tailoring Supplier"] = "Merchants",
        ["Speciality Tailoring Supplies"] = "Merchants",
        ["Tabard Vendor"] = "Merchants",
        ["Fish Vendor"] = "Merchants",
        ["Food and Drink"] = "Food and Drink",
        ["Guild Tabard Vendor"] = "Merchants",
        ["Cloth & Leather Merchant"] = "Merchants",
        ["Arcane Goods Vendor"] = "Merchants",
        ["Special Weapon Crafter"] = "Miscellaneous",
        ["Leatherworking Supplies"] = "Merchants",
        ["Superior Armor Crafter"] = "Armor",
        ["Butcher"] = "Food and Drink",
        ["Trade Goods Supplies"] = "Merchants",
        ["Trade Goods Vendor"] = "Merchants",
        ["Scrolls & Potions"] = "Miscellaneous",
        ["Food & Drink Merchant"] = "Merchants",
        ["Leatherworking & Tailoring Supplies"] = "Merchants",
        ["General Goods Vendor"] = "Merchants",
        ["Cooking Supplier"] = "Merchants",
        ["Rations"] = "Food and Drink",
        ["Mail Armor Merchant"] = "Merchants",
        ["Bag Vendor"] = "Merchants",
        ["Engineering Supplier"] = "Merchants",
        ["Fishing Trainer & Supplies"] = "Merchants",
        ["Supplies"] = "Merchants",
        ["Healing & Sustenance"] = "Food and Drink",
        ["Blacksmithing Supplier"] = "Merchants",
        ["Axe Merchant"] = "Merchants",
        ["Staff & Mace Merchant"] = "Merchants",
        ["Blacksmithing Supplies"] = "Merchants",
        ["Keepers of Time Quartermaster"] = "Miscellaneous",
        ["Specialist Tailoring Supplies"] = "Merchants",
        ["Drink Vendor"] = "Merchants",
        ["Mace & Staves Vendor"] = "Merchants",
        ["General Trade Goods Merchant"] = "Merchants",
        ["Leather Armor Merchant"] = "Merchants",
        ["Innkeeper"] = "Food and Drink",
        ["Defilers Supply Officer"] = "Merchants",
        ["Wine & Spirits Merchant"] = "Merchants",
    },
}

Cartographer_Vendors.icons = {
	["Vendor"] = {
		text = L["Vendor"],
		path = "Interface\\AddOns\\Cartographer_Vendors\\Artwork\\INV_Misc_ElvenCoins",
		width = 14,
		height = 14
	},
    ["Armorer"] = {
        text = L["Armorer"],
        path = "Interface\\AddOns\\Cartographer_Vendors\\Artwork\\INV_Misc_ElvenCoins",
        width = 14,
        height = 14,
    },
}

Cartographer_Vendors.vendors = {}

Cartographer_Vendors.noteDefaults = {
	titleCol = Cartographer_Notes.getColorID(0, 0.8, 0)
}
Cartographer_Vendors.noteLocaleHandler = L

function Cartographer_Vendors:OnInitialize()
	self:RegisterDefaults("profile", {
		filters = {
			['*'] = true,
		},
        iconAlpha = 1,
		iconScale = 1,
        minimapIcons = true,
        minimapTracking = true,
        noteRadius = 15,        
	})
    
    self:RegisterDefaults("faction", {
        vendors = {
            ['*'] = {
                ['*'] = {},
            },
        },
    })

	local aceopts = {}
	aceopts.toggle = {
		name = AceLibrary("AceLocale-2.2"):new("Cartographer")["Enabled"],
		desc = AceLibrary("AceLocale-2.2"):new("Cartographer")["Suspend/resume this module."],
		type  = 'toggle',
		order = -1,
		get   = function() return Cartographer:IsModuleActive(self) end,
		set   = function() Cartographer:ToggleModuleActive(self) end,
	}

	aceopts.alpha = {
		name = L["Icon alpha"],
		desc = L["Alpha transparency of the icon"],
		type = 'range',
		min = 0.1,
		max = 1,
		step = 0.05,
		isPercent = true,
        set = function(v)
            self.db.profile.iconAlpha = v
            Cartographer_Notes:RefreshMap()
        end,
        get = function() return self.db.profile.iconAlpha end,
		order = 1
	}
	aceopts.scale = {
		name = L["Icon size"],
		desc = L["Size of the icons on the map"],
		type = 'range',
		min = 0.5,
		max = 2,
		step = 0.05,
		isPercent = true,
        set = function(v) 
            self.db.profile.iconScale = v
            Cartographer_Notes:RefreshMap()
        end,
        get = function() return self.db.profile.iconScale end,
		order = 2
	}    
    aceopts.minimapicons = {
		name = L["Show minimap icons"],
		desc = L["Show vendor icons on the minimap"],
		type = 'toggle',
        set = function()
            self.db.profile.minimapIcons = not self.db.profile.minimapIcons
            Cartographer_Notes:RefreshMap()
        end,
        get = function() return self.db.profile.minimapIcons end,
		order = 3,
	}
    
    aceopts.minimaptracking = {
        name = L["Show minimap tracking icons"],
        desc = L["Show vendor tracking icons on the minimap"],
        type = 'toggle',
        set = function() 
            self.db.profile.minimapTracking = not self.db.profile.minimapTracking
            Cartographer_Notes:RefreshMap()
        end,
        get = function() return self.db.profile.minimapTracking end,
        order = 4,
        hidden = function() return not self.db.profile.minimapIcons end,
    }
    
	aceopts.filter = {
		name = L["Filter"],
		desc = L["Filter out vendors"],
		type = 'group',
		args = {
			all = {
				name = L["Select all"],
				desc = L["Select all"],
				type = 'execute',
				func = function()
					for k in pairs(self.filters) do
						self:ToggleShowingVendors(k, true)
					end
				end,
				order = 1,
			},
			none = {
				name = L["Select none"],
				desc = L["Select none"],
				type = 'execute',
				func = function()
					for k in pairs(self.filters) do
						self:ToggleShowingVendors(k, false)
					end
				end,
				order = 2,
			},
			blank = {
				type = 'header',
				order = 3,
			}
		},
        order = 5,
        -- hidden = true,
	}

    aceopts.rebuild = {
        name = L["Rebuild"],
        desc = L["Rebuild vendors"],
        type = 'execute',
        func = "RebuildVendors",
        order = 6,
    }

   	Cartographer.options.args.Vendors = {
		name = L["Vendors"],
		desc = L["Module description"],
		type = 'group',
		args = aceopts,
		handler = self,
	}
	-- AceLibrary("AceConsole-2.0"):InjectAceOptionsTable(self, Cartographer.options.args.Vendors)

	for k,v in pairs(self.filters) do
		local k = k
		aceopts.filter.args[k] = {
			name = v,
			desc = v,
			type = 'toggle',
			get = function()
				return self:IsShowingVendors(k)
			end,
			set = function(value)
				return self:ToggleShowingVendors(k, value)
			end,
		}
	end
    
    if (not self.db.faction.notes) then self.db.faction.notes = {} end
    
    local oldDB = Cartographer:AcquireDBNamespace("Vendors")
    if (oldDB.faction.notes) then
        for k, v in pairs(oldDB.faction.notes) do
            if (k ~= "version") and (v ~= nil) then
                if (not self.db.faction.notes[k]) then self.db.faction.notes[k] = {} end
                for vk, vv in pairs(v) do
                    if (vv ~= nil) then
                        if (not self.db.faction.notes[k][vk]) then
                            -- self.db.faction.notes[k][vk] = {}
                            self.db.faction.notes[k][vk] = vv
                        end
                    end
                end
            end
        end
    end
    oldDB = nil    
   
end

function Cartographer_Vendors:OnEnable()
	if Cartographer_Notes then
		if not self.iconsregistered then
			for k,v in pairs(self.icons) do
				Cartographer_Notes:RegisterIcon(k, v)
			end
			self.iconsregistered = true
		end

		Cartographer_Notes:RegisterNotesDatabase('Vendors', self.db.faction.notes, self)
	else
		Cartographer:ToggleModuleActive(self, false)
	end

    self:RegisterEvent("MERCHANT_SHOW", function() self:RegisterVendor(UnitName("NPC")) end, 2)
end

function Cartographer_Vendors:OnDisable()
	self:UnregisterAllEvents()

	if Cartographer_Notes then
		Cartographer_Notes:UnregisterNotesDatabase('Vendors')
	end
end

function Cartographer_Vendors:SetNote(vendor)
    if (type(vendor) == "string") then vendor = {["name"] = vendor} end
    if (type(vendor) ~= "table") then return end
    
    if (not vendor.x) or (vendor.y) then vendor.x, vendor.y = GetPlayerMapPosition("player") end
    if (vendor.x == 0) and (vendor.y == 0) then return end
    
    if (not vendor.zone) then vendor.zone = GetRealZoneText() end
    
    local note = {}
    note.title = vendor.name
    note.icon = "Vendor"
    note.info = "Vendor"

    if (vendor.type) then
        if (self.filters[self.lookups.filters[vendor.type]] and self.icons[vendor.type]) then note.icon = vendor.type end
        note.info = vendor.type
    end
    
	-- for zone, x_p, y_p, icon, creator, data in Cartographer_Notes:IterateNearbyNotes(vendor.zone, vendor.x, vendor.y, 15, "Vendors", nil, true) do
    for zone, x_p, y_p, icon, creator, data in Cartographer_Notes:IterateNearbyNotes(vendor.zone, vendor.x, vendor.y, (self.db.profile.noteRadius or 15), "Vendors", nil, true) do
		if data.title == note.title then
			Cartographer_Notes:DeleteNote(zone, x_p, y_p)
		end
	end
	Cartographer_Notes:SetNote(vendor.zone, vendor.x, vendor.y, note.icon, "Vendors", note)
end

function Cartographer_Vendors:RegisterVendor(vendor)
    if (not vendor) then return end
    if (type(vendor) ~= "string") then return end
    
    local zone = GetRealZoneText()
    local x,y = GetPlayerMapPosition("player")
    
    -- DEFAULT_CHAT_FRAME:AddMessage(string.format("RegisterVendor: %s", vendor))

    local entry = {}    
    -- if (not self.db.faction.vendors[zone]) then self.db.faction.vendors[zone] = {} end    
    if (not self.db.faction.vendors[zone][vendor]) then
        -- DEFAULT_CHAT_FRAME:AddMessage(string.format("RegisterVendor: %s not found", vendor))        
        
        entry.name = vendor
        entry.x = x
        entry.y = y
        Tooltip:SetUnit("npc")
        local result = Tooltip:GetLine(2)
        if (result) then entry.type = result end
        entry.faction = UnitFactionGroup("player")
        
        self.db.faction.vendors[zone][vendor] = entry
    end
    
    entry = self.db.faction.vendors[zone][vendor]
    entry.zone = zone
    
    --[[
    if (entry.name) then
        DEFAULT_CHAT_FRAME:AddMessage(string.format("RegisterVendor: Calling SetNote for %s (%s) in %s", entry.name, entry.type, entry.zone))    
    else
        DEFAULT_CHAT_FRAME:AddMessage(string.format("RegisterVendor: %s FUBAR", vendor))
    end
    --]]
    
    self:SetNote(entry)
end

<<<<<<< .mine
function Cartographer_Vendors:IsNoteHidden(zone, id, vendor)
=======
function mod:ImportVendors()
    if (mod.vendors) then
        local faction = UnitFactionGroup("player")
        DEFAULT_CHAT_FRAME:AddMessage("Cartographer Notes: Start import.")
        for k,v in pairs(mod.vendors) do
            if (v ~= nil) then
                for kv, vv in pairs(v) do
                    if (vv ~= nil) then
                        if (not vv.faction) or (vv.faction == faction) then
                            local entry = vv
                            entry.zone = k
                            
                            if (entry.x ~= 0) and (entry.y ~= 0) then
                                local note = {}
                                note.title = entry.name
                                note.icon = "Vendor"
                                -- note.info = L["Vendor"]
                                note.info = "Vendor"
                                
                                if (entry.type) then
                                    if (mod.filters[entry.type] and mod.icons[entry.type]) then note.icon = entry.type end
                                    -- note.info = L[entry.type]
                                    note.info = entry.type
                                end

                                for zone, x_p, y_p, icon, creator, data in Cartographer_Notes:IterateNearbyNotes(entry.zone, entry.x, entry.y, 15, "Vendors", nil, true) do
                                    if data.title == note.title then
                                        Cartographer_Notes:DeleteNote(zone, x_p, y_p)
                                    end
                                end
                                
                                Cartographer_Notes:SetNote(entry.zone, entry.x, entry.y, note.icon, "Vendors", note)                            
                            end
                        end
                    end
                end
            end
        end
       DEFAULT_CHAT_FRAME:AddMessage("Cartographer Notes: Import complete.")
    end
end

mod.noteDefaults = {
	titleCol = Cartographer_Notes.getColorID(0, 0.8, 0)
}
mod.noteLocaleHandler = L

function mod:IsNoteHidden(zone, id, vendor)
>>>>>>> .r25965
	if type(vendor) == "table" then
		return not self.db.profile.filters[self.lookups.filters[vendor.info]]
    else
		return not self.db.profile.filters[self.lookups.filters[vendor]]
	end
end

function Cartographer_Vendors:IsShowingVendors(vendortype)
	return self.db.profile.filters[vendortype]
end

function Cartographer_Vendors:ToggleShowingVendors(vendortype, value)
	if value == nil then
		value = not self.db.profile.filters[vendortype]
	end
	self.db.profile.filters[vendortype] = value

	Cartographer_Notes:RefreshMap()
end

function Cartographer_Vendors:IsTracking(zone,id,data)
    return self.db.profile.minimapTracking
end

function Cartographer_Vendors:IsMiniNoteHidden(zone,id,data)
	return not self.db.profile.minimapIcons
end

function Cartographer_Vendors:GetNoteTransparency(zone,id,data)
	return self.db.profile.iconAlpha
end

function Cartographer_Vendors:GetNoteScaling(zone,id,data)
	return self.db.profile.iconScale
end

function Cartographer_Vendors:RebuildVendors()
    local result = self.db.faction.vendors
    
    if (self.module_import) then
        for k,v in pairs(self:ImportVendors()) do
            if (v ~= nil) then
                if (not result[k]) then result[k] = {} end
                for vk,vv in pairs(v) do
                    if (vv ~= nil) then
                        result[k][vk] = vv
                    end
                end
            end
        end
    end
            
    if (result) then
        DEFAULT_CHAT_FRAME:AddMessage("Cartographer Vendor: Start rebuild.")
        -- for k, v in pairs(self.db.faction.vendors) do
        for k,v in pairs(result) do
            if (v ~= nil) then
                for kv, vv in pairs(v) do
                    if (vv ~= nil) then
                        local entry = vv
                        if (not entry.name) then entry.name = kv end
                        entry.zone = k
                        
                        if (entry.x ~= 0) and (entry.y ~= 0) then
                            local note = {}
                            note.title = entry.name
                            note.icon = "Vendor"
                            note.info = "Vendor"
                            
                            if (entry.type) then
                                if (self.filters[self.lookups.filters[entry.type]] and self.icons[entry.type]) then note.icon = entry.type end
                                note.info = entry.type
                            end
                            
                            for zone, x_p, y_p, icon, creator, data in Cartographer_Notes:IterateNearbyNotes(entry.zone, entry.x, entry.y, 15, "Vendors", nil, true) do
                                if data.title == note.title then
                                    Cartographer_Notes:DeleteNote(zone, x_p, y_p)
                                end
                            end
                            
                            -- DEFAULT_CHAT_FRAME:AddMessage(string.format("Cartographer Vendor: Rebuilding note ==> %s in %s (%s,%s)", entry.name, entry.zone, entry.x, entry.y))
                            -- DEFAULT_CHAT_FRAME:AddMessage(string.format("Cartographer Vendor: Rebuilding note ==> %s in %s (%s,%s)", entry.name, entry.zone, entry.x * 100, entry.y * 100))
                            Cartographer_Notes:SetNote(entry.zone, entry.x, entry.y, note.icon, "Vendors", note)                            
                        end
                    end
                end
            end
        end
        self.db.faction.vendors = result
        DEFAULT_CHAT_FRAME:AddMessage("Cartographer Vendor: Rebuild complete.")
    end
end
